/* $Date: 1996/10/08 18:02:31 $  $Author: kg $  $Revision: 1.19 $ */

/**************************************************************************/
/* FILE:             MIO_io.h                                             */
/* Autor:            Oliver Kluge, Andreas Kemper, Ralf Hillebrand        */ 
/* Erstellt:         27/06/91                                             */ 
/* Letzte Aenderung: 31/08/94                                             */ 
/**************************************************************************/ 
 
#ifndef __MIO_io__
#define __MIO_io__

#ifdef NEWCOMMUNICATION
#  ifdef DOS_FILENAMES
#    include "MPR_prot.h"
#  else
#    include "MPR_protocol.h"
#  endif
#endif

/**************************************************************************/ 
/* Dieses File enthaelt die Routinen zur Ausgabe.                         */  
/**************************************************************************/ 
 
/* Formatierte Bildschirmausgabe der Zahl 'i'.				*/
/* Die Formatanweisung  's' darf genau ein Element besitzen.		*/ 

#define MIO_print_format_number(s, i) \
{ sprintf(MIOV_BUFFER, s, i); MIO_print_string(MIOV_BUFFER); }

#define MIO_print_format_string(s, i) MIO_print_format_number(s, i)

/* Verwaltung des aktuellen Ausgabetyps MIOV_OUTPUT_TYPE */
#ifdef NEWCOMMUNICATION
#define MIOC_LOCAL_TYPE MPRTtype MIOV_local_type;
#define MIOC_PUSH_TYPE(t) { if (XMUPAD) \
    { MUP_fflush(stdout); MIOV_local_type = MIOV_OUTPUT_TYPE; MIOV_OUTPUT_TYPE = (t); } }
#define MIOC_POP_TYPE { if (XMUPAD) \
    { MUP_fflush(stdout); MIOV_OUTPUT_TYPE = MIOV_local_type; } }
#else
#define MIOC_LOCAL_TYPE
#define MIOC_PUSH_TYPE(t)
#define MIOC_POP_TYPE
#endif

/* Berechnung des Maximums zweier Zahlen            */

#define MIO_max(a,b) (((a)<(b))?(b):(a))

typedef S_Pointer (*MIOT_outfunction_pointer)(S_Pointer *, S_Pointer, long, S_Pointer) ;

void MIO_out(S_Pointer);
void MIO_create_debug(S_Pointer *,FILE *, long, long *);
#ifdef MDX
S_Pointer MIO_out_cat_debug(S_Pointer,long);
#define MIOC_RESTORE 0L
#define MIOC_SET  1L
#define MIOC_RESET 2L
void MIO_change_global( long );
#endif
S_Pointer MIO_out_cat_ident(S_Pointer,long);
S_Pointer MIO_out_cat_string(S_Pointer,long);
S_Pointer MIO_out_cat_bool(S_Pointer,long);
S_Pointer MIO_out_cat_null(S_Pointer,long);
S_Pointer MIO_out_cat_nil(S_Pointer,long);
S_Pointer MIO_out_cat_failed(S_Pointer,long);
S_Pointer MIO_out_cat_set(S_Pointer,long);
S_Pointer MIO_out_cat_stat_list(S_Pointer,long);
S_Pointer MIO_out_cat_table(S_Pointer,long);
S_Pointer MIO_out_cat_exec (S_Pointer,long) ;
S_Pointer MIO_out_cat_func_env(S_Pointer,long);
S_Pointer MIO_out_cat_point(S_Pointer,long);
S_Pointer MIO_out_cat_poly(S_Pointer,long);
S_Pointer MIO_out_cat_polygon(S_Pointer,long);
S_Pointer MIO_print_number(S_Pointer,long);
S_Pointer MIO_print_complex_number(S_Pointer,long);
S_Pointer MIO_out_cat_array(S_Pointer s,long priority);
S_Pointer MIO_out_cat_funcarg(S_Pointer,long);
S_Pointer MIO_out_cat_namespace(S_Pointer,long);

void MIO_pari_print_number(S_Pointer);
S_Pointer MIO_atom2text(S_Pointer);

void MIO_init(VOID);
void MIO_exit(VOID);
void MIO_reset(VOID);
void MIO_test(S_Pointer,int);
S_Pointer MIO_out_seqgen(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_stand_op(S_Pointer *,S_Pointer,long ,S_Pointer);
S_Pointer MIO_out_stand_op_pretty(S_Pointer,S_Pointer ,long ,S_Pointer);
S_Pointer MIO_out_stand_sys_func(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_domattr(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_index(S_Pointer *,S_Pointer,long,S_Pointer);

S_Pointer MIO_out_assign(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_if(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_case(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_for(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_for_par(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_for_down(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_for_in(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_for_in_par(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_while(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_repeat(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_next(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_break(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_quit(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_parbegin(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_seqbegin(S_Pointer *,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_string(S_Pointer);
S_Pointer MIO_out_cat_proc(S_Pointer,long);
S_Pointer MIO_out_cat_ext(S_Pointer,long) ;
S_Pointer MIO_out_cat_dom(S_Pointer,long) ;

S_Pointer MIO_expr2text(S_Pointer);

S_Pointer MIO_print_symbol(S_Pointer);

#ifndef PARI_C_PLUSPLUS
MDE_externCstart
#endif
void MIO_print_string(char *);
void MIO_print_char(char);
#ifndef PARI_C_PLUSPLUS
MDE_externCend
#endif

void MIO_write(char);

#ifndef MACINTOSH

void MIO_put_char(char);

#endif 


/******************* Vordefinierte Konstanten ****************************/

#define MIOC_P_NULL             0
#define MIOC_P_STMTSEQ          1
#define MIOC_P_EXPRSEQ          2
#define MIOC_P_OR               3
#define MIOC_P_AND              4
#define MIOC_P_SEQGEN           5
#define MIOC_P_LESS             6
#define MIOC_P_LEEQUAL          6
#define MIOC_P_EQUAL            6
#define MIOC_P_UNEQUAL          6
#define MIOC_P_RANGE            7
#define MIOC_P_UNION            8
#define MIOC_P_MINUS            9
#define MIOC_P_INTERSECT       10
#define MIOC_P_MOD             11
#define MIOC_P_PLUS            12
#define MIOC_P_MULT            13
#define MIOC_P_POWER           14
#define MIOC_P_FCONCAT	       15
#define MIOC_P_CONCAT          16
#define MIOC_P_STMT            17


#define MIOC_P_max             18
 
#define PLUS_BIT                8
 
#define MIOT_FIELDSIZE long       /* Datenfeldgroesse im Ausgabebaum */



extern S_Pointer MIOV_DOMAIN_ASS_OUTPUT ;
extern S_Pointer MIOV_DOMAIN_ASS_EXPR2TEXT ;
#ifdef NEWCOMMUNICATION
extern MPRTtype MIOV_OUTPUT_TYPE;   /* Typ der Ausgabe bei Kommunikation 
			      * mittels MPR, zulaessige Typen werden in 
		              * MPR_protocol.h definiert. */
#endif

#endif /* __MIO_io__ */
